/// Provides serialization classes to use with [xml_annotation](https://pub.dev/packages/xml_annotation).
library xml_serializable;

export 'package:xml_serializable/src/builder_generators/builder_generator.dart';
export 'package:xml_serializable/src/builder_generators/iterable_builder_generator.dart';
export 'package:xml_serializable/src/builder_generators/xml_attribute_builder_generator.dart';
export 'package:xml_serializable/src/builder_generators/xml_cdata_builder_generator.dart';
export 'package:xml_serializable/src/builder_generators/xml_root_element_builder_generator.dart';
export 'package:xml_serializable/src/builder_generators/xml_serializable_xml_element_builder_generator.dart';
export 'package:xml_serializable/src/builder_generators/xml_text_builder_generator.dart';
export 'package:xml_serializable/src/builder_generators/xml_text_xml_element_builder_generator.dart';
export 'package:xml_serializable/src/constructor_generators/constructor_generator.dart';
export 'package:xml_serializable/src/constructor_generators/iterable_constructor_generator.dart';
export 'package:xml_serializable/src/constructor_generators/xml_attribute_constructor_generator.dart';
export 'package:xml_serializable/src/constructor_generators/xml_cdata_constructor_generator.dart';
export 'package:xml_serializable/src/constructor_generators/xml_root_element_constructor_generator.dart';
export 'package:xml_serializable/src/constructor_generators/xml_serializable_xml_element_constructor_generator.dart';
export 'package:xml_serializable/src/constructor_generators/xml_text_constructor_generator.dart';
export 'package:xml_serializable/src/constructor_generators/xml_text_xml_element_constructor_generator.dart';
export 'package:xml_serializable/src/extensions/class_element_extensions.dart';
export 'package:xml_serializable/src/extensions/constant_reader_extensions.dart';
export 'package:xml_serializable/src/extensions/dart_object_extensions.dart';
export 'package:xml_serializable/src/extensions/dart_type_extensions.dart';
export 'package:xml_serializable/src/extensions/element_annotation_extensions.dart';
export 'package:xml_serializable/src/extensions/element_extensions.dart';
export 'package:xml_serializable/src/extensions/field_element_extensions.dart';
export 'package:xml_serializable/src/generator_factories/builder_generator_factory.dart';
export 'package:xml_serializable/src/generator_factories/constructor_generator_factory.dart';
export 'package:xml_serializable/src/generator_factories/getter_generator_factory.dart';
export 'package:xml_serializable/src/generator_factories/serializer_generator_factory.dart';
export 'package:xml_serializable/src/getter_generators/getter_generator.dart';
export 'package:xml_serializable/src/getter_generators/xml_attribute_getter_generator.dart';
export 'package:xml_serializable/src/getter_generators/xml_cdata_getter_generator.dart';
export 'package:xml_serializable/src/getter_generators/xml_element_getter_generator.dart';
export 'package:xml_serializable/src/getter_generators/xml_element_iterable_getter_generator.dart';
export 'package:xml_serializable/src/getter_generators/xml_text_getter_generator.dart';
export 'package:xml_serializable/src/serializer_generators/bool_serializer_generator.dart';
export 'package:xml_serializable/src/serializer_generators/date_time_serializer_generator.dart';
export 'package:xml_serializable/src/serializer_generators/double_serializer_generator.dart';
export 'package:xml_serializable/src/serializer_generators/duration_serializer_generator.dart';
export 'package:xml_serializable/src/serializer_generators/dynamic_serializer_generator.dart';
export 'package:xml_serializable/src/serializer_generators/enum_serializer_generator.dart';
export 'package:xml_serializable/src/serializer_generators/int_serializer_generator.dart';
export 'package:xml_serializable/src/serializer_generators/iterable_serializer_generator.dart';
export 'package:xml_serializable/src/serializer_generators/num_serializer_generator.dart';
export 'package:xml_serializable/src/serializer_generators/serializer_generator.dart';
export 'package:xml_serializable/src/serializer_generators/string_serializer_generator.dart';
export 'package:xml_serializable/src/serializer_generators/stringable_serializer_generator.dart';
export 'package:xml_serializable/src/serializer_generators/uri_serializer_generator.dart';
export 'package:xml_serializable/src/type_checkers/xml_attribute_type_checker.dart';
export 'package:xml_serializable/src/type_checkers/xml_cdata_type_checker.dart';
export 'package:xml_serializable/src/type_checkers/xml_element_type_checker.dart';
export 'package:xml_serializable/src/type_checkers/xml_root_element_type_checker.dart';
export 'package:xml_serializable/src/type_checkers/xml_serializable_type_checker.dart';
export 'package:xml_serializable/src/type_checkers/xml_text_type_checker.dart';
export 'package:xml_serializable/src/xml_enum_generator.dart';
export 'package:xml_serializable/src/xml_serializable_generator.dart';
